<template>
	<view class="cancelStockPages" :style="`backgroundImage:linear-gradient(180deg, ${$config('primaryColor')}, #F5F6F7 12%)`">
		<view class="cancelStockPages-body">
			<view class="head-info" v-if="basicInfoData">
				<view class="states">
					<view>
						<u-icon name="icon_withdrawal" custom-prefix="iscm-icon" size="48"></u-icon>
						<text>待退库</text>
					</view>
				</view>
				<view>
					<view class="label"><u-icon name="ison_shelf" custom-prefix="iscm-icon" size="32"></u-icon><text>货架名称</text></view>
					<view class="info-txt">{{basicInfoData.shelfInfo&&basicInfoData.shelfInfo.shelfName || '--'}}</view>
				</view>
				<view>
					<view class="label"><u-icon name="icon_position" custom-prefix="iscm-icon" size="32"></u-icon><text>客户地址</text></view>
					<view class="info-txt">{{basicInfoData.customerAddr || '--'}}</view>
				</view>
			</view>
			<view class="part-list">
				<!-- 配件列表 -->
				<partList title="配件列表" fromPage="recall" ref="partList" :list="partList" @allChecked="allCheckedCallback"></partList>
			</view>
		</view>
		<view class="cancelStockPages-footer">
			<view>
				<u-checkbox size="40" @change="allCheckeChange" v-model="allChecked" shape="circle">{{allChecked?'取消全选':'全选'}}</u-checkbox>
			</view>
			<view>
				<u-button @click="submit" shape="circle" :custom-style="{background:$config('primaryColor')}" type="primary">确定退库</u-button>
			</view>
		</view>
		<!-- 确认弹框 -->
		<common-modal :openModal="confirmModal" content="调回产品将退回至经销商仓库，确认退库吗？" confirmText="确认退库" @confirm="modalConfirm" @close="confirmModal=false" />
	</view>
</template>

<script>
	import commonModal from '@/pages/common/commonModal.vue'
	import partList from '@/pages/common/partList.vue'
	import { shelfRecallFindBySn, shelfRecallDetail, shelfRecallConfirm } from '@/api/shelfRecall.js'
	export default {
		components: { commonModal, partList },
		data() {
			return {
				allChecked: false,
				recallBillSn: '',
				basicInfoData: null,
				partList: [],
				confirmModal: false,
			}
		},
		onReady() {
			uni.setNavigationBarColor({
				frontColor: '#ffffff',
				backgroundColor: this.$config('primaryColor')
			})
		},
		onLoad(option) {
			this.recallBillSn = option.sn
			this.getDetail()
			this.getPartList()
		},
		methods: {
			// 全选
			allCheckeChange(e){
				this.$refs.partList.allSelect(e.value)
			},
			allCheckedCallback(val){
				this.allChecked = val
			},
			// 查询详情
			getDetail(){
				shelfRecallFindBySn({sn: this.recallBillSn}).then(res => {
					if(res.status == 200){
						this.basicInfoData = res.data || null
					}else{
						this.basicInfoData = null
					}
				})
			},
			// 查询配件列表
			getPartList(){
				shelfRecallDetail({ recallBillSn: this.recallBillSn }).then(res => {
					if(res.status == 200 && res.data){
						res.data.map(item =>{
							item.confirmQty = item.qty ? Number(item.qty) : 0
						})
						this.partList = res.data || []
						console.log(res.data)
					}else{
						this.partList = []
					}
				})
			},
			// 确定退货
			submit(){
				const result =this.$refs.partList.getAllChecked()
				if(result.length){
					this.confirmModal = true
				}else{
					this.toashMsg("请选择配件！")
				}
			},
			// 确认退库 confirm
			modalConfirm(){
				const result =this.$refs.partList.getAllChecked()
				const arr = []
				result.map((item, index) => {
					if (item.confirmQty || item.confirmQty == 0) {
						arr.push({
							productSn: item.productSn,
							confirmQty: item.confirmQty,
							recallBillDetailSn: item.recallBillDetailSn
						})
					}
				})
				const params = {
					shelfSn: result[0].shelfSn,
					recallBillSn: this.recallBillSn,
					recallBillNo: result[0].recallBillNo,
					detailList: arr
				}
				shelfRecallConfirm(params).then(res => {
					if(res.status == 200){
						uni.$emit("refreshBL")
						uni.navigateBack()
					}
					this.toashMsg(res.message)
				})
			}
		}
	}
</script>

<style lang="less">
	page {
		height: 100vh;
	}
.cancelStockPages{
	position: relative;
	width: 100%;
	height: 100%;
	overflow: hidden;
	padding-bottom: 136upx;
	.cancelStockPages-body{
		padding: 0 30rpx;
		height: 100%;
		overflow: auto;
		> view{
			padding: 10rpx 25rpx;
			background-color: #fff;
			margin-bottom: 20rpx;
			border-radius: 25rpx;
			box-shadow: 2rpx 3rpx 5rpx #eee;
		}
		.head-info{
			.states{
				border: 0;
				padding: 20rpx 0;
				> view{
					color: #191919;
					text-align: center;
					font-size: 40rpx;
					text{
						margin-left: 20rpx;
					}
				}
			}
			.info-txt{
				word-break: break-word;
			}
			font-size: 30rpx;
			> view{
				display: flex;
				border-bottom: 2rpx solid #f5f5f5;
				padding: 20rpx 0;
				> view:last-child{
					flex-grow: 1;
					width: 80%;
				}
				&:last-child{
					border:0;
				}
			}
			.label{
				display: flex;
				align-items: center;
				width: 220rpx;
				height: 44rpx;
				color: #7C7D7E;
				text{
					margin-left: 10rpx;
				}
			}
		}
	}
	.cancelStockPages-footer{
		padding: 26upx 32upx 30upx;
		background-color: #fff;
		position: fixed;
		left: 0;
		bottom: 0;
		width: 100%;
		box-shadow: 3px 1px 7px #eee;
		display: flex;
		justify-content: space-between;
		align-items: center;
		.button{
			width: 45%;
		}
	}
}
</style>
